% waypoint pgm map edit utility 
% E-mail: ikko@hosei.ac.jp
% http://www.gerox.com
%Example 
% step.1 select pgm file eg. hoseisaka1027.pgm
% step.2 select waypoint yaml file eg. hoseisakawaypoints1027.yaml
% step.3 select zoom icon and/or drag and move star mark
% [RemoveNoise] button
% push mouse left button and specify remove noise area by using mouse 
% then mouse left button click and select image trimming
% [WritePGM]
% write pgm file and wapoints file which are renamed.
% Three files are gnenerated such as 
% hoseisaka1027_remap.pgm
% hoseisaka1027_remap.yaml
% hoseisakawaypoints1027_remap.yaml
% [x] Add point
% step.1 select check box
% step.2 select star mark then new star mark is insterted
% step.3 automatically deselect check box
close all;clear all
% remap mode remapmode = 1
% hoseisaka1027.pgm ->hoseisaka1027_remap.pgm
% org mode   remapmode = 0
% hoseisaka1027.pgm ->hoseisaka1027.pgm original files are backuped like hoseisaka1027.20171019081149.pgm  
remapmode=1;
orgdate=char(datetime);
orgdate(strfind(orgdate,':'))='';
orgdate(strfind(orgdate,' '))='';
orgdate(strfind(orgdate,'/'))='';

if isunix
  !synclient HorizTwoFingerScroll=0
end

if 0
[filename0, pathname0] = uigetfile('/home/kbkn/catkin_ws/src/orne_navigation/orne_navigation_executor/maps/*.pgm', 'Please input PGM file');
else
[filename0, pathname0] = uigetfile('./maps/*.pgm', 'Please input PGM file');% for demo program
end
img=imread([pathname0,filename0]);
imgdata=ReadYaml([pathname0,filename0(1:end-3),'yaml']);
if 0
[filename1, pathname1] = uigetfile('/home/kbkn/catkin_ws/src/orne_navigation/orne_navigation_executor/waypoints_cfg/*.yaml', 'Please input waypint yaml file');
else
[filename1, pathname1] = uigetfile('./waypoints_cfg/*.yaml', 'Please input waypoint yaml file');
end
data=ReadYaml([pathname1,filename1]);

xyzdata=[];
for i=1:length(data.waypoints)
    xyzdata=[xyzdata;[data.waypoints{i}.point.x,data.waypoints{i}.point.y,data.waypoints{i}.point.z]];
end
fxyzdata=[data.finish_pose.pose.position.x,data.finish_pose.pose.position.y,data.finish_pose.pose.position.z];
xyzdata=xyzdata-repmat([imgdata.origin{1},imgdata.origin{2},imgdata.origin{3}],length(xyzdata),1);
fxyzdata=fxyzdata-repmat([imgdata.origin{1},imgdata.origin{2},imgdata.origin{3}],1,1);
xyzdata=xyzdata/imgdata.resolution;
fxyzdata=fxyzdata/imgdata.resolution;
[row,col]=size(img);
xyzdata(:,2)=row-xyzdata(:,2);
fxyzdata(:,2)=row-fxyzdata(:,2);
fig1=figure;
ih=imshow(img);axis on
ihtmp=gca;
val=ihtmp.XTick;

for i=1:length(val);ihtmp.XTickLabel{i}=val(i)*imgdata.resolution/10;end
val=ihtmp.YTick;
for i=1:length(val);ihtmp.YTickLabel{i}=val(i)*imgdata.resolution/10;end
hold all
plot(fxyzdata(1),fxyzdata(2),'rp');axis equal
t=[0,cumsum(sqrt(sum((xyzdata(1:end-1,1:2)-xyzdata(2:end,1:2)).^2,2)))'];
tt=0:10:t(end);
xx=interp1(t,xyzdata(:,1),tt,'spline');
yy=interp1(t,xyzdata(:,2),tt,'spline');
plt1(length(data.waypoints)+1)=plot(xx,yy,'-');
for i=1:length(data.waypoints)
plt1(i)=plot(xyzdata(i,1),xyzdata(i,2),'p','markersize',10,'tag',num2str(i));
drawnow;
end
axis equal
hold off
btn=0;mode=0;
fig1.Units='normalized';
axes1=gca;axes1.Units='normalized';
axes1.SortMethod='childorder';
fig1.WindowButtonDownFcn='tukubagui3';
fig1.WindowButtonMotionFcn='if(btn==1) [xyzdata,plt1]=tukubagui2(2,xyzdata,plt1);end;';
fig1.WindowButtonUpFcn='btn=0;[xyzdata,plt1]=tukubagui2(3,xyzdata,plt1);';
ui(1)=uicontrol('Position',[20 30 100 20],'String','WritePGM','callback','tukubaremap(xyzdata,data,img,imgdata,filename0, pathname0,filename1,pathname1,remapmode,orgdate);');
ui(2)=uicontrol('Position',[20 10 100 20],'String','RemoveNoise','callback','tukubadenoise;');
ui(3)=uicontrol('Position',[20 50 100 20],'Style','checkbox','String','Insert Point','callback','h1=zoom;h2=pan;h1.Enable=''off'';h2.Enable=''off'';ui(4).Value=0;');
ui(4)=uicontrol('Position',[20 70 100 20],'Style','checkbox','String','Delete Point','callback','h1=zoom;h2=pan;h1.Enable=''off'';h2.Enable=''off'';ui(3).Value=0;');
ui(5)=title('Please select Waypoint(drag/insert/delete)');

